/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"

#include "iodefine.h"



#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

volatile int step_r,step_l;


//vOR[h8.1
void init_clock(void){
	SYSTEM.PRCR.WORD   = 0xa50b;			//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;			// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;				// PLL ENABLE
	SYSTEM.SCKCR.LONG  = 0x21C21211;		//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;			// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;				// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;			//PLLHI
}

//vOR[hR[h8.6
void motor_init(void)
{
//I/O̐ݒ
	PORT1.PODR.BIT.B5 = 0;
	PORT1.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B6 = 1;
	MPC.PWPR.BIT.B0WI = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.P17PFS.BIT.PSEL = 1;
	MPC.PE2PFS.BIT.PSEL = 1;
	MPC.PWPR.BYTE = 0x80;
	PORT1.PMR.BIT.B7 = 1;
	PORTE.PMR.BIT.B2 = 1;
//MTU3,4̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	MTU.TSTR.BYTE = 0;
//E[^\pMTUݒ
	MTU3.TCR.BIT.CCLR = 1;
	MTU3.TCR.BIT.TPSC = 2;
	MTU3.TMDR.BIT.MD = 2;
	MTU3.TIORH.BIT.IOA = 2;
	MTU3.TIORH.BIT.IOB = 1;
	MTU3.TGRA = 6297;
	MTU3.TGRB = 50;
	MTU3.TGRC = 6297;
	MTU3.TMDR.BIT.BFA = 1;
	MTU3.TIER.BIT.TGIEB = 1;
	IEN(MTU3,TGIB3) = 1;
	IPR(MTU3,TGIB3) = 13;
	IR(MTU3,TGIB3) = 0;
//[^\pMTUݒ
	MTU.TOER.BIT.OE4A = 1;
	MTU4.TCR.BIT.CCLR = 1;
	MTU4.TCR.BIT.TPSC = 2;
	MTU4.TMDR.BIT.MD = 2;
	MTU4.TIORH.BIT.IOA = 2;
	MTU4.TIORH.BIT.IOB = 1;
	MTU4.TGRA = 6297;
	MTU4.TGRB = 50;
	MTU4.TGRC = 6297;
	MTU4.TMDR.BIT.BFA = 1;
	MTU4.TIER.BIT.TGIEB = 1;
	IEN(MTU4,TGIB4) = 1;
	IPR(MTU4,TGIB4) = 12;
	IR(MTU4,TGIB4) = 0;
	MTU3.TCNT = 0;
	MTU4.TCNT = 0;
}

//vOR[h9.1
void main(void)
{
	int i,j;
	
	init_clock();
	PORT1.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B6 = 1;
	PORTE.PDR.BIT.B2 = 1;
	
	PORTC.PODR.BIT.B6 = 1;
	PORT1.PODR.BIT.B5 = 1;
	for(j=0;j<0x1000;j++);
	
	for(i=0;i<400;i++){
		PORTE.PODR.BIT.B2=1;
		for(j=0;j<0x3000;j++);
		PORTE.PODR.BIT.B2=0;
		for(j=0;j<0x3000;j++);
	}
	while(1);
}		
/*
//vOR[h9.2
void main(void)
{
	int j;
	
	init_clock();
	motor_init();
	
	PORTC.PODR.BIT.B6=1;
	PORT1.PODR.BIT.B5=1;
	
	for(j=0;j<0x1000;j++);
	
	MTU.TSTR.BIT.CST4 = 1;
	while(1);
}
*/
/*
//vOR[h9.5
void main(void)
{
	int j;
	
	init_clock();
	motor_init();
	
	PORTC.PODR.BIT.B6=1;
	PORT1.PODR.BIT.B5=1;
	
	for(j=0;j<0x1000;j++);
	
	step_l=0;
	MTU.TSTR.BIT.CST4 = 1;
	while(step_l < 400);
	MTU.TSTR.BIT.CST4 = 0;
	
	while(1);
	
}
*/


#ifdef __cplusplus
void abort(void)
{

}
#endif
